#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <Adafruit_MCP23X17.h> 
Adafruit_MCP23X17 mcp0;
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
SoftwareSerial mySoftwareSerial(3, 1); // RX, TX
DFRobotDFPlayerMini myDFPlayer;
 

  /* Встановіть тут свій SSID та пароль */
  const char* ssid = "NodeMCU";       // SSID
  const char* password = "12345678";  // пароль
  
  /* Настройки IP адреса */
  IPAddress local_ip(192,168,1,2);
  IPAddress gateway(192,168,1,2);
  IPAddress subnet(255,255,255,0);
  
  ESP8266WebServer server(80);
  
  /* Десятки */                   /* Одиниці */
  uint8_t SegmentA1 = 0;        uint8_t SegmentA2 = 8;
  uint8_t SegmentB1 = 1;        uint8_t SegmentB2 = 9;
  uint8_t SegmentC1 = 2;        uint8_t SegmentC2 = 10;
  uint8_t SegmentD1 = 3;        uint8_t SegmentD2 = 11;
  uint8_t SegmentE1 = 4;        uint8_t SegmentE2 = 12;
  uint8_t SegmentF1 = 5;        uint8_t SegmentF2 = 13;
  uint8_t SegmentG1 = 6;        uint8_t SegmentG2 = 14;
 
  long K = 0;
  
  bool Add   = LOW;
  bool Minus = LOW;
  bool Reset = LOW;
  
  
  void setup(){
    
    Serial.begin(115200);
    mcp0.begin_I2C(0x20); //A0 - 0; A1 - 0; A2 - 0;
    
      /* Оголошення десятків*/                    /* Оголошення Одиниць*/
   
    mcp0.pinMode(SegmentA1, OUTPUT);          mcp0.pinMode(SegmentA2, OUTPUT);
    mcp0.pinMode(SegmentB1, OUTPUT);          mcp0.pinMode(SegmentB2, OUTPUT);
    mcp0.pinMode(SegmentC1, OUTPUT);          mcp0.pinMode(SegmentC2, OUTPUT);
    mcp0.pinMode(SegmentD1, OUTPUT);          mcp0.pinMode(SegmentD2, OUTPUT);
    mcp0.pinMode(SegmentE1, OUTPUT);          mcp0.pinMode(SegmentE2, OUTPUT);
    mcp0.pinMode(SegmentF1, OUTPUT);          mcp0.pinMode(SegmentF2, OUTPUT);
    mcp0.pinMode(SegmentG1, OUTPUT);          mcp0.pinMode(SegmentG2, OUTPUT);

    WiFi.softAP(ssid, password);
    WiFi.softAPConfig(local_ip, gateway, subnet);
    delay(100);
    server.on("/",handle_OnConnect);
    server.on("/ADD_TRUE", handle_ADD);
    server.on("/MINUS_TRUE", handle_MINUS);
    server.on("/RESET_TRUE", handle_RESET);
    server.onNotFound(handle_NotFound);
    server.begin();
    mySoftwareSerial.begin(9600);
    myDFPlayer.volume(30);
    Serial.println("HTTP server started");
    Antworte(K);
  }


  void loop(){
    server.handleClient();
    if(Add){
      K++;
      Antworte(K); 
      server.send(200, "text/html", SendHTML(K));
      Add = LOW; 
      myDFPlayer.play(1);
    }
    if(Reset){
      K=0;
      Antworte(K);
      server.send(200, "text/html", SendHTML(K));
      Reset = LOW;
      myDFPlayer.play(1);
    }
    if(Minus){
      if(K==0){
        K=0;
        Antworte(K); 
        server.send(200, "text/html", SendHTML(K)); 
      }
      else{
        K--;
        Antworte(K);
        server.send(200, "text/html", SendHTML(K));
      }
      Minus = LOW;
      myDFPlayer.play(1);
    }
  }

  
  int Antworte(byte x){
      if(x<10){
        mcp0.digitalWrite(SegmentA1,HIGH);
        mcp0.digitalWrite(SegmentB1,HIGH);
        mcp0.digitalWrite(SegmentC1,HIGH);
        mcp0.digitalWrite(SegmentD1,HIGH);
        mcp0.digitalWrite(SegmentE1,HIGH);
        mcp0.digitalWrite(SegmentF1,HIGH);
        mcp0.digitalWrite(SegmentG1,LOW);
        Einheiten(x);
        return 0;
      }
      else{
        byte Number = x;
        byte a = 0, b = 0;
        a=Number/10;
        b=Number%10;
        Dutzende(a);
        Einheiten(b);
        return 0;
      }
  }

  int Dutzende(byte c){
        switch(c){
          case 1:
            mcp0.digitalWrite(SegmentA1,LOW);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,LOW);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,LOW);
            mcp0.digitalWrite(SegmentG1,LOW);
            break;
          case 2:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,LOW);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,HIGH);
            mcp0.digitalWrite(SegmentF1,LOW);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          case 3:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,LOW);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          case 4:
            mcp0.digitalWrite(SegmentA1,LOW);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,LOW);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,HIGH);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          case 5:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,LOW);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,HIGH);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          case 6:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,LOW);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,HIGH);
            mcp0.digitalWrite(SegmentF1,HIGH);
            mcp0.digitalWrite(SegmentG1,HIGH); 
            break;
          case 7:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,LOW);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,LOW);
            mcp0.digitalWrite(SegmentG1,LOW);
            break;
          case 8:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,HIGH);
            mcp0.digitalWrite(SegmentF1,HIGH);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          case 9:
            mcp0.digitalWrite(SegmentA1,HIGH);
            mcp0.digitalWrite(SegmentB1,HIGH);
            mcp0.digitalWrite(SegmentC1,HIGH);
            mcp0.digitalWrite(SegmentD1,HIGH);
            mcp0.digitalWrite(SegmentE1,LOW);
            mcp0.digitalWrite(SegmentF1,HIGH);
            mcp0.digitalWrite(SegmentG1,HIGH);
            break;
          default:
            break;
        }
        return 0;
      }
  int Einheiten(byte d){
      switch(d){
         case 0:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,HIGH);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,LOW);
            break;
          case 1:
            mcp0.digitalWrite(SegmentA2,LOW);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,LOW);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,LOW);
            mcp0.digitalWrite(SegmentG2,LOW);
            break;
          case 2:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,LOW);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,HIGH);
            mcp0.digitalWrite(SegmentF2,LOW);
            mcp0.digitalWrite(SegmentG2,HIGH);
            break;
          case 3:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,LOW);
            mcp0.digitalWrite(SegmentG2,HIGH);
            break;
          case 4:
            mcp0.digitalWrite(SegmentA2,LOW);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,LOW);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,HIGH);
            break;
          case 5:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,LOW);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,HIGH);
            break;
          case 6:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,LOW);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,HIGH);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,HIGH); 
            break;
          case 7:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,LOW);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,LOW);
            mcp0.digitalWrite(SegmentG2,LOW);
            break;
          case 8:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,HIGH);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,HIGH);
            break;
          case 9:
            mcp0.digitalWrite(SegmentA2,HIGH);
            mcp0.digitalWrite(SegmentB2,HIGH);
            mcp0.digitalWrite(SegmentC2,HIGH);
            mcp0.digitalWrite(SegmentD2,HIGH);
            mcp0.digitalWrite(SegmentE2,LOW);
            mcp0.digitalWrite(SegmentF2,HIGH);
            mcp0.digitalWrite(SegmentG2,HIGH); 
            break;
          default:
            break;
      }
      return 0;
    }
    void handle_OnConnect(){
       Serial.println("OK");
       server.send(200, "text/html", SendHTML(K));
    }
    void handle_ADD(){
        Add = HIGH;
    }
    void handle_MINUS(){
        Minus = HIGH;
    }
    void handle_RESET(){
        Reset = HIGH;  
    }
    void handle_NotFound(){
        server.send(404, "text/plain", "Not found");
    }
    String SendHTML(int Nummer){
        String ptr = "<!DOCTYPE html> <html>\n";
        ptr +="<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no\">\n";
        ptr +="<title>Tafel</title>\n"; 
        ptr +="<style>body{background-color: antiquewhite;}\n"; 
        ptr +=".printBlock{font-size: 64px; color: #ff0000; height: 8vh;}\n";
        ptr +="div{text-align: center;}\n";
        ptr +=".wrapbutton{display: flex; flex-direction: column; justify-content: space-between; align-items: center; width: 100%; height: 35vh; margin:auto; padding-top: 1em;}\n";
        ptr +=".divbutt{display: flex; width: 75%; margin: 2vh auto 0; align-content: space-around; flex-wrap: wrap;}\n";
        ptr +=".button {font-size: 48px; text-decoration: none; color: #ffffff; background-color: #459bfd; width: 100%; padding: 0.4em; border: 0; border-top-left-radius: 1.7em 1.5em; border-top-right-radius: 1.7em 1.5em; border-bottom-right-radius: 1.7em 1.5em; border-bottom-left-radius: 1.7em 1.5em;}\n";
        ptr +=".text{font-size: 3em; text-align: center;}\n";
        ptr +=".text1{ font-size: 2em;text-align: center;}\n";
        ptr +="</style>\n";
        ptr +="</head>\n";
        ptr +="<body>\n";
        ptr +="<h1 class=\"text\">ESP8266 Project</h1>\n";
        ptr +="<h2 class=\"text1\">Tafel</h2>\n";
        ptr +="<div class=\"printBlock\">";
        ptr +=(int)Nummer;
        ptr += "</div>\n";
        ptr +="<div class=\"wrapbutton\">\n";
        ptr +="<div class=\"divbutt\"><a class=\"button\" type=\"submit\" id=\"mybutton1\" href=\"/ADD_TRUE\">+1</a></div>\n";
        ptr +="<div class=\"divbutt\"><a class=\"button\" type=\"submit\" id=\"mybutton2\" href=\"/MINUS_TRUE\">-1</a></div>\n";
        ptr +="<div class=\"divbutt\"><a class=\"button\" type=\"submit\" id=\"mybutton3\" href=\"/RESET_TRUE\">reset</a></div>\n";
        ptr +="</div>\n";
        ptr +="</body>\n";
        ptr +="</html>\n";
        return ptr;
    }
    
